#include <GL/gl.h>
#include <GL/glu.h>
#include "../include/ball.h"

Ball::Ball()
{
    x = 0;
    y = 0;
    z = 0;
    launched = false;
    xvel = 0.5;
    yvel = 0.75;
}

void Ball::draw()
{
    glPushMatrix();

    GLfloat jaune[4] = { 0.4, 0.4, 0.0,0.5};
    GLfloat rien[4]={0.0,0.0,0.0,0.0};
    glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,jaune); //lampe jaune dans la balle

    glColor3ub(200, 200, 0);
    glTranslated(x, y, 0);

    GLUquadric *params = gluNewQuadric();       //création du quadrique
    gluQuadricTexture(params, GL_TRUE); //activation des coordonnées de texture
    gluSphere(params, 1, 20, 20);

    //mess cleanup
    gluDeleteQuadric(params);   //je supprime le quadrique
    glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,rien);
    glPopMatrix();
}

bool Ball::isgoingdown()
{
    if(yvel < 0)
        return true;
    else
        return false;
}

void Ball::followbat(GLdouble X, GLdouble Y, GLdouble Z)
{
    x = X;
    y = Y + 1.5;
    z = Z;
}

void Ball::launch()
{
    launched = true;
}

void Ball::brickcollision(char direction)
{
    switch(direction)
    {
    case 'x':xvel =-xvel;break;
    case 'y':yvel =-yvel;break;
    default:break;
    }  
}

void Ball::deplacement(char direction)
{
    switch(direction)
    {
    case 'x':
        x += xvel;break;
    case 'y':
        y += yvel;break;
    default:break;
    }
    checkCollision();
}

void Ball::batcollision(GLdouble X, GLdouble Y, GLdouble Z)
{
    xvel = 10*((x-X)/100);
    yvel = -yvel;
}

void Ball::checkCollision()
{
    if (y <= -40)
    {
        launched = false;
        xvel = 0.5;
        yvel = 0.75;
    }
    else
    {
        if (x >= 40 || x <= -40)
        {
            xvel = -xvel;
            x += xvel;
        }
        if (y >= 35)
        {
            yvel = -yvel;
            y += yvel;
        }
    }
}
