#include <GL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>

#include <stdio.h>

#include "../include/debris.h"


Debris::Debris(GLdouble X,GLdouble Y,GLdouble Z,Debris *n,Debris *p)
{
    x = X;
    y = Y;
    z = Z;
    next = n;
    prev = p;

    xvel=(rand()%15-7.5)/10;
    yvel=(rand()%15-7.5)/10;
    zvel=(rand()%15-7.5)/10;

    gravity=-0.02;

    height=(float)(rand()%20)/18;
    width=(float)(rand()%20)/20;

    glPushMatrix();

    glLoadIdentity();
    glRotated((rand()%30)/3.0,(rand()%30)/3.0,(rand()%30)/3.0,1);
    glGetDoublev(GL_MODELVIEW_MATRIX, rotation);

    glLoadIdentity();
    glGetDoublev(GL_MODELVIEW_MATRIX, orientation);

    glPopMatrix();

}


Debris::~Debris()
{
    if (next == NULL && prev != NULL)
        prev->next = NULL;
    else if (prev == NULL && next != NULL)
        next->prev = NULL;
    else if (next != NULL && prev != NULL)
    {
        next->prev = prev;
        prev->next = next;
    }
}

void Debris::draw()
{
    move();

    glPushMatrix();
    glTranslated(x, y, z);
    glMultMatrixd(orientation);

    glColor3ub(230, 130, 120);

    glBegin(GL_QUADS);

    glNormal3i(0,0,1);	
    glVertex3d(width, height, 0);
    glVertex3d(-width, height, 0);
    glVertex3d(-width, -height, 0);
    glVertex3d(width, -height, 0);

    glEnd();

    glPopMatrix();
}

void Debris::move()
{
    yvel+=gravity;
    x += xvel;
    y +=yvel;
    z +=zvel;

    if(x<= -40 || x >= 40)
        xvel=-xvel;

    glPushMatrix();
    glLoadIdentity();
    glMultMatrixd(orientation);
    glMultMatrixd(rotation);
    glGetDoublev(GL_MODELVIEW_MATRIX, orientation);
    glPopMatrix();

}



void Destroy(Debris **first,Debris *target)
{
    if (target->prev == NULL)
        *first = target->next;
    delete target;
}

void DebrisCleaner(Debris **first)
{
    Debris *current = *first;
    Debris *buffer;
    while (current != NULL)    
    {
        buffer=current->next;
        if(current->y < -40)
        {
            if(current==*first)
                *first=(*first)->next;
            Destroy(first,current);
        }
        current=buffer; 
    }
}

void DrawDebris(Debris *first)
{
    Debris *current = first;
    while (current != NULL)    
    {
        current->draw();
        current = current->next;
    }
}

void CreateDebris(Debris **first,GLdouble X,GLdouble Y, GLdouble Z)
{
    Debris *current=*first;
    int quantite=6+rand()%3;
    int i=1;

    Debris *next;

    if(current != NULL)
    {
        while(current->next != NULL)
        {
            current=current->next;
        }
        current->next = new Debris(X, Y, 0, NULL, current);
        current=current->next;
    }
    else
    {
        *first = new Debris(X, Y, 0, NULL, NULL);
        current=*first;
    }

    while (i < quantite)
    {
            next = new Debris(X, Y, 0, NULL, current);
            current->next = next;
            current = current->next;
            i++;
    }
}
